//////////////////////////////////////////////////////////
//   This class has been automatically generated 
//     (Tue May 13 16:34:01 2003 by ROOT version3.05/05)
//   from TTree h2000/run
//   found on file: emec_12369.root
//////////////////////////////////////////////////////////


#ifndef EmecRunHeader2002v0_h
#define EmecRunHeader2002v0_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <string>
#include <iostream>

using std::string;
using std::cout;
using std::endl;

/*! - Class EmecRunHeader2002v0
  * - Author: Ian Gable (igable@uvic.ca)
  * - Date:  05/27/2003
  * - Description: This class was created by root 3.05/05. Use it to access the information
  *      contained in the Emec Run Header.
  */

class EmecRunHeader2002v0 {
   public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //!current Tree number in a TChain


   EmecRunHeader2002v0(TTree *tree=0,string fileName=0);
   ~EmecRunHeader2002v0();
   Int_t  Cut(Int_t entry);
   Int_t  GetEntry(Int_t entry);
   Int_t  LoadTree(Int_t entry);
   void   Init(TTree *tree);
   void   Loop();
   Bool_t Notify();
   void   Show(Int_t entry = -1);

   //! first FEB channel number
   UInt_t getFirstCh(){ return first_ch;};

   //! last FEB channel number
   UInt_t getLastCh(){ return last_ch;};

   //! peak finding method (polynomial=1, digital filtering=2)
   Int_t peakMethod() {return peakf; };

   //! cal Version number of calibration file (if digital filtering is used)
   UInt_t calVersion(){return cal_version;};

   //! Version number of weight parameters files (if digital filtering is used)
   UInt_t digVersion(){return dig_version;};

   //! Shower model type ("0" for real data)
   UInt_t getShower(){return shower;};

   //! Unit of energy (ADC=1, nA=2)
   UInt_t getEUnit(){return eunit;};

   //! The number of adc channels
   Int_t getCellsUsed(){return cells_used;};

   Float_t getPedRms(int febno){
    if(febno >= getFirstCh() && febno <= getLastCh() ){
      return ped_rms[febno];
    } else {
      cout << "Ped RMS accessed out of bounds at: " << febno <<endl;
      exit(1);
    }
  }

private:

//Declaration of leaves types
   UInt_t          first_ch;
   UInt_t          last_ch;
   Int_t           peakf;
   UInt_t          cal_version;
   UInt_t          dig_version;
   UInt_t          shower;
   UInt_t          eunit;
   Int_t           cells_used;
   Float_t         ped_rms[1152];   //[cells_used]
   Int_t           ieta[1152];   //[cells_used]
   Int_t           iphi[1152];   //[cells_used]
   Int_t           iz[1152];   //[cells_used]

//List of branches
   TBranch        *b_first_ch;   //!
   TBranch        *b_last_ch;   //!
   TBranch        *b_peakf;   //!
   TBranch        *b_cal_version;   //!
   TBranch        *b_dig_version;   //!
   TBranch        *b_shower;   //!
   TBranch        *b_eunit;   //!
   TBranch        *b_cells_used;   //!
   TBranch        *b_ped_rms;   //!
   TBranch        *b_ieta;   //!
   TBranch        *b_iphi;   //!
   TBranch        *b_iz;   //!
};

#endif

#ifdef EmecRunHeader2002v0_cxx
EmecRunHeader2002v0::EmecRunHeader2002v0(TTree *tree,string fileName)
{
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.
   TFile *f ;
   if (tree == 0) {
         f = new TFile(fileName.c_str());

      tree = (TTree*)f->Get("h2000");

   }
   Init(tree);
}

EmecRunHeader2002v0::~EmecRunHeader2002v0()
{
   if (!fChain) return;
   delete fChain->GetCurrentFile();
}

Int_t EmecRunHeader2002v0::GetEntry(Int_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Int_t EmecRunHeader2002v0::LoadTree(Int_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Int_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (fChain->IsA() != TChain::Class()) return centry;
   TChain *chain = (TChain*)fChain;
   if (chain->GetTreeNumber() != fCurrent) {
      fCurrent = chain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void EmecRunHeader2002v0::Init(TTree *tree)
{
//   Set branch addresses
   if (tree == 0) return;
   fChain    = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("first_ch",&first_ch);
   fChain->SetBranchAddress("last_ch",&last_ch);
   fChain->SetBranchAddress("peakf",&peakf);
   fChain->SetBranchAddress("cal_version",&cal_version);
   fChain->SetBranchAddress("dig_version",&dig_version);
   fChain->SetBranchAddress("shower",&shower);
   fChain->SetBranchAddress("eunit",&eunit);
   fChain->SetBranchAddress("cells_used",&cells_used);
   fChain->SetBranchAddress("ped_rms",ped_rms);
   fChain->SetBranchAddress("ieta",ieta);
   fChain->SetBranchAddress("iphi",iphi);
   fChain->SetBranchAddress("iz",iz);
   Notify();
}

Bool_t EmecRunHeader2002v0::Notify()
{
   // Called when loading a new file.
   // Get branch pointers.
   b_first_ch = fChain->GetBranch("first_ch");
   b_last_ch = fChain->GetBranch("last_ch");
   b_peakf = fChain->GetBranch("peakf");
   b_cal_version = fChain->GetBranch("cal_version");
   b_dig_version = fChain->GetBranch("dig_version");
   b_shower = fChain->GetBranch("shower");
   b_eunit = fChain->GetBranch("eunit");
   b_cells_used = fChain->GetBranch("cells_used");
   b_ped_rms = fChain->GetBranch("ped_rms");
   b_ieta = fChain->GetBranch("ieta");
   b_iphi = fChain->GetBranch("iphi");
   b_iz = fChain->GetBranch("iz");
   return kTRUE;
}

void EmecRunHeader2002v0::Show(Int_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t EmecRunHeader2002v0::Cut(Int_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return 1;
}
#endif // #ifdef EmecRunHeader2002v0_cxx

