//////////////////////////////////////////////////////////
//   This class has been automatically generated 
//     (Thu May  9 16:45:13 2002 by ROOT version3.01/06)
//   from TTree h101/standard
//   found on file: hec_adc_11555_nov8_20k.root
//////////////////////////////////////////////////////////


#ifndef EventNTuple2001v0_h
#define EventNTuple2001v0_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <string>

/*! -Class:    EventNTuple2001v0
  - Author:   Ian Gable (igable@uvic.ca)
  - Date:      05/08/2003
  - Description: This class reads the contents of a 2001 Hec Test Beam ntuple
  */

using std::string;
class EventNTuple2001v0 {
   public :
   TTree          *fChain;   //pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //current Tree number in a TChain
//Declaration of leaves types
   UInt_t          hec_evtno;
   UInt_t          hec_trig[5];
   Int_t           hec_nchan;
   Float_t         hec_signal[310];

	//List of branches
   TBranch        *b_hec_evtno;
   TBranch        *b_hec_trig;
   TBranch        *b_hec_nchan;
   TBranch        *b_hec_signal;

   EventNTuple2001v0(TTree* tree=0,string fileName=0);
   //EventNTuple2001v0(TTree *tree=0);
   ~EventNTuple2001v0();
   Int_t  Cut(Int_t entry);
   Int_t  GetEntry(Int_t entry);
   Int_t  LoadTree(Int_t entry);
   void   Init(TTree *tree);
   void   Loop();
   Bool_t Notify();
   void   Show(Int_t entry = -1);

   int numEvents();
};

#endif

#ifdef EventNTuple2001v0_cxx
EventNTuple2001v0::EventNTuple2001v0(TTree *tree,string fileName)
{
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.
   if (tree == 0) {
      TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject(fileName.c_str());
      if (!f) {
         f = new TFile(fileName.c_str());
      }
      tree = (TTree*)gDirectory->Get("h101");

   }
   Init(tree);
}

EventNTuple2001v0::~EventNTuple2001v0()
{
   if (!fChain) return;
   //delete fChain->GetCurrentFile();  // comented out because of core dump
}

Int_t EventNTuple2001v0::GetEntry(Int_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Int_t EventNTuple2001v0::LoadTree(Int_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Int_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (fChain->IsA() != TChain::Class()) return centry;
   TChain *chain = (TChain*)fChain;
   if (chain->GetTreeNumber() != fCurrent) {
      fCurrent = chain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void EventNTuple2001v0::Init(TTree *tree)
{
//   Set branch addresses
   if (tree == 0) return;
   fChain    = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("hec_evtno",&hec_evtno);
   fChain->SetBranchAddress("hec_trig",hec_trig);
   fChain->SetBranchAddress("hec_nchan",&hec_nchan);
   fChain->SetBranchAddress("hec_signal",hec_signal);
   Notify();
}

Bool_t EventNTuple2001v0::Notify()
{
//   called when loading a new file
//   get branch pointers
   b_hec_evtno = fChain->GetBranch("hec_evtno");
   b_hec_trig = fChain->GetBranch("hec_trig");
   b_hec_nchan = fChain->GetBranch("hec_nchan");
   b_hec_signal = fChain->GetBranch("hec_signal");
   return kTRUE;
}

void EventNTuple2001v0::Show(Int_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t EventNTuple2001v0::Cut(Int_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return 1;
}

int EventNTuple2001v0::numEvents(){
  return  int(fChain->GetEntries());
}
#endif // #ifdef EventNTuple2001v0_cxx

