
#ifndef  HecEnergyLayerAlg_H
#define HecEnergyLayerAlg_H

//#include "HecRunHeader2001v0.h"
#include "HecRunHeader2002v0.h"
//#include "HecEvent.h"
#include "Event.h"
#include "Geometry.h"
#include "TH1.h"
#include "TCanvas.h"
#include "TProfile.h"
#include "SystemAlg.h"

/*! -Class:    HecEnergyLayerAlg
  - Author:   Ian Gable (igable@uvic.ca)
  - Date:      06/042002
  - Description: HecEnergyLayerAlg will create a plot that contains a histogram for every
                      layer of the calorimeter and a profile Histogram containing all the layers.
  */
class HecEnergyLayerAlg : public SystemAlg {
public:

  /** The user should never need to use this contructor
    * @param event A pointer in the event. Information contained in the event
    *                             gets refreshed before the execute method is run
    * @param hecGeom Pointer to the singleton Geometry object
    * @param runHeader Pointer to the singleton HecRunHeader object
    */

  HecEnergyLayerAlg(Event* event, Geometry* hecGeom, Headers* runHeader);
  ~HecEnergyLayerAlg();

  //! Gets run once at the begining of the event Loop
  bool initialize();

  //! Gets run for every event
  bool execute();

  //! Gets run after all events have been executed
  bool finalize();

  void setInteractive(bool interactive){ m_interactive = interactive; };

  bool isInteractive(){ return m_interactive; };

private:
  Geometry* m_geo;
  Event* m_event;
  Headers* m_runHeader;

  TH1F* energy[4];
  TProfile* profile;
  bool m_interactive;

  //################################
  //### insert your memeber variables here


  //################################
};

#endif
