
#include "SystemAlg.h"

#include <sstream>
#include <string>



SystemAlg::SystemAlg(Event* event, Geometry* geo, Headers* runHeader){
  m_event = event;
  m_geo = geo;
  m_runHeader = runHeader;
}

void SystemAlg::setAlgs(vector<SystemAlg*> algs){
  m_algVector = algs;
}



// initialize any variables here
bool SystemAlg::initialize(){
  vector<SystemAlg*>::iterator itr;

  for(itr = m_algVector.begin(); itr != m_algVector.end(); itr++){
    (*itr)->initialize();
  }

  return true;
}

// put any code you want executed per event here
bool SystemAlg::execute(){
  vector<SystemAlg*>::iterator itr;

  for(itr = m_algVector.begin(); itr != m_algVector.end(); itr++){
    (*itr)->execute();
  }

  return true;
}


bool SystemAlg::finalize(){
  vector<SystemAlg*>::iterator itr;

  for(itr = m_algVector.begin(); itr != m_algVector.end(); itr++){
    (*itr)->finalize();
  }
  return true;
}
