
#include "UserAlg.h"

#include <sstream>
#include <string>

using std::cout;
using std::endl;
using std::vector;
using std::string;

UserAlg::UserAlg(Event* event, Geometry* geo, Headers* runHeader):SystemAlg( event,geo,runHeader){
  m_event = event;
  m_geo = geo;
  m_runHeader = runHeader;

  // create the new System Alg Objects
  m_clusterBuilder = new HecClusterBuildAlg(m_event, m_geo, m_runHeader);
  m_plotAllCells = new PlotAllCellsAlg(m_event, m_geo, m_runHeader);
  m_hecEnergyLayer = new HecEnergyLayerAlg(m_event,m_geo,m_runHeader);
  vector<SystemAlg*> algVector;

  //push the algorithms onto the list
  //algVector.push_back(m_clusterBuilder);
  //algVector.push_back(m_plotAllCells);
  m_hecEnergyLayer->setInteractive(false);
  //algVector.push_back(m_hecEnergyLayer);
  SystemAlg::setAlgs(algVector);

}


// initialize any variables here
bool UserAlg::initialize(){
  SystemAlg::initialize(); //do NOT remove this line


  return true;
}

// put any code you want executed per event here
bool UserAlg::execute(){
  SystemAlg::execute(); //do NOT remove this line

  return true;
}

//put any code here that you want executed after all the events have been processed.
bool UserAlg::finalize(){
  SystemAlg::finalize();//do NOT remove this line


  return true;
}
